weka.filters.unsupervised.instance

## Class ReservoirSample

- java.lang.Object
- - weka.filters.Filter
  - - weka.filters.unsupervised.instance.ReservoirSample

- All Implemented Interfaces:
    java.io.Serializable, CapabilitiesHandler, CapabilitiesIgnorer, OptionHandler, RevisionHandler, StreamableFilter, UnsupervisedFilter

      public class ReservoirSample
      extends Filter
      implements UnsupervisedFilter, OptionHandler, StreamableFilter

  Produces a random subsample of a dataset using the reservoir sampling Algorithm "R" by Vitter. The original data set does not have to fit into main memory, but the reservoir does.

  BibTeX:

       @article{Vitter1985,
          author = {J. S. Vitter},
          journal = {ACM Transactions on Mathematical Software},
          number = {1}
          volume = {11}
          pages = {37-57},
          title = {Random Sampling with a Reservoir},
          year = {1985}
       }

  Valid options are:

       -S <num>
        Specify the random number seed (default 1)

       -Z <num>
        The size of the output dataset - number of instances
        (default 100)

  Version:
    $Revision: 10215 $
  Author:
    Mark Hall (mhall{[at]}pentaho{[dot]}org)
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ReservoirSample()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `batchFinished()` Signify that this batch of input to the filter is finished.
    `Capabilities` | `getCapabilities()` Returns the Capabilities of this filter.
    `java.lang.String[]` | `getOptions()` Gets the current settings of the filter.
    `int` | `getRandomSeed()` Gets the random number seed.
    `java.lang.String` | `getRevision()` Returns the revision string.
    `int` | `getSampleSize()` Gets the subsample size.
    `java.lang.String` | `globalInfo()` Returns a string describing this filter
    `boolean` | `input(Instance instance)` Input an instance for filtering.
    `java.util.Enumeration<Option>` | `listOptions()` Returns an enumeration describing the available options.
    `static void` | `main(java.lang.String[] argv)` Main method for testing this class.
    `java.lang.String` | `randomSeedTipText()` Returns the tip text for this property
    `java.lang.String` | `sampleSizeTipText()` Returns the tip text for this property
    `boolean` | `setInputFormat(Instances instanceInfo)` Sets the format of the input instances.
    `void` | `setOptions(java.lang.String[] options)` Parses a given list of options.
    `void` | `setRandomSeed(int newSeed)` Sets the random number seed.
    `void` | `setSampleSize(int newSampleSize)` Sets the size of the subsample.

    - ### Methods inherited from class weka.filters.Filter

      `batchFilterFile, debugTipText, doNotCheckCapabilitiesTipText, filterFile, getCapabilities, getDebug, getDoNotCheckCapabilities, getOutputFormat, isFirstBatchDone, isNewBatch, isOutputFormatDefined, makeCopies, makeCopy, mayRemoveInstanceAfterFirstBatchDone, numPendingOutput, output, outputPeek, runFilter, setDebug, setDoNotCheckCapabilities, toString, useFilter, wekaStaticWrapper`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ReservoirSample

          public ReservoirSample()

  - ### Method Detail

    - #### globalInfo

          public java.lang.String globalInfo()

      Returns a string describing this filter
      Returns:
        a description of the classifier suitable for displaying in the explorer/experimenter gui

    - #### listOptions

          public java.util.Enumeration<Option> listOptions()

      Returns an enumeration describing the available options.
      Specified by:
        `listOptions` in interface `OptionHandler`
      Overrides:
        `listOptions` in class `Filter`
      Returns:
        an enumeration of all the available options.

    - #### setOptions

          public void setOptions(java.lang.String[] options)
                          throws java.lang.Exception

      Parses a given list of options.

      Valid options are:

           -S <num>
            Specify the random number seed (default 1)

           -Z <num>
            The size of the output dataset - number of instances
            (default 100)

      Specified by:
        `setOptions` in interface `OptionHandler`
      Overrides:
        `setOptions` in class `Filter`
      Parameters:
        `options` - the list of options as an array of strings
      Throws:
        `java.lang.Exception` - if an option is not supported

    - #### getOptions

          public java.lang.String[] getOptions()

      Gets the current settings of the filter.
      Specified by:
        `getOptions` in interface `OptionHandler`
      Overrides:
        `getOptions` in class `Filter`
      Returns:
        an array of strings suitable for passing to setOptions

    - #### randomSeedTipText

          public java.lang.String randomSeedTipText()

      Returns the tip text for this property
      Returns:
        tip text for this property suitable for displaying in the explorer/experimenter gui

    - #### getRandomSeed

          public int getRandomSeed()

      Gets the random number seed.
      Returns:
        the random number seed.

    - #### setRandomSeed

          public void setRandomSeed(int newSeed)

      Sets the random number seed.
      Parameters:
        `newSeed` - the new random number seed.

    - #### sampleSizeTipText

          public java.lang.String sampleSizeTipText()

      Returns the tip text for this property
      Returns:
        tip text for this property suitable for displaying in the explorer/experimenter gui

    - #### getSampleSize

          public int getSampleSize()

      Gets the subsample size.
      Returns:
        the subsample size

    - #### setSampleSize

          public void setSampleSize(int newSampleSize)

      Sets the size of the subsample.
      Parameters:
        `newSampleSize` - size of the subsample.

    - #### getCapabilities

          public Capabilities getCapabilities()

      Returns the Capabilities of this filter.
      Specified by:
        `getCapabilities` in interface `CapabilitiesHandler`
      Overrides:
        `getCapabilities` in class `Filter`
      Returns:
        the capabilities of this object
      See Also:
        `Capabilities`

    - #### setInputFormat

          public boolean setInputFormat(Instances instanceInfo)
                                 throws java.lang.Exception

      Sets the format of the input instances.
      Overrides:
        `setInputFormat` in class `Filter`
      Parameters:
        `instanceInfo` - an Instances object containing the input instance structure (any instances contained in the object are ignored - only the structure is required).
      Returns:
        true if the outputFormat may be collected immediately
      Throws:
        `java.lang.Exception` - if the input format can't be set successfully

    - #### input

          public boolean input(Instance instance)

      Input an instance for filtering. Filter requires all training instances be read before producing output.
      Overrides:
        `input` in class `Filter`
      Parameters:
        `instance` - the input instance
      Returns:
        true if the filtered instance may now be collected with output().
      Throws:
        `java.lang.IllegalStateException` - if no input structure has been defined

    - #### batchFinished

          public boolean batchFinished()

      Signify that this batch of input to the filter is finished. If the filter requires all instances prior to filtering, output() may now be called to retrieve the filtered instances.
      Overrides:
        `batchFinished` in class `Filter`
      Returns:
        true if there are instances pending output
      Throws:
        `java.lang.IllegalStateException` - if no input structure has been defined

    - #### getRevision

          public java.lang.String getRevision()

      Returns the revision string.
      Specified by:
        `getRevision` in interface `RevisionHandler`
      Overrides:
        `getRevision` in class `Filter`
      Returns:
        the revision

    - #### main

          public static void main(java.lang.String[] argv)

      Main method for testing this class.
      Parameters:
        `argv` - should contain arguments to the filter: use -h for help